//office.c
#include <stdlib.h>
#include <stdio.h>
#include "office.h"
#define _MaxN	100001
#define true 1
#define false 0

int _Init = true;
int _digi = 129723562;
int _N, _Qnum, _maxQ1, _maxQ2, _maxQ4;
int _Apa[_MaxN];

void _Fin(int OK, char*  S){
int point=0;
   if (OK) {
      if (_Qnum <= _maxQ4) {
         point = 4;
         S=" <=N/2+2";
    } else if (_Qnum <= _maxQ2) {
         point = 2;
         S=" <=2N/3";
    } else {
         point = 1;
         S=" <=N-3";
    }
    printf("%d\n", point);
    printf("Correct\n");
    printf("#Questions= %d %s\n", _Qnum, S);
    printf("%d\n",_digi);
    exit(0);
  }
  printf("0\n");
  printf("%s\n",S);
  printf("#Questions= %d\n", _Qnum);
  printf("%d\n",_digi);
  exit(0);
}  /*_Fin*/

 void _doInit(){
  int x;
    scanf("%d", &_N);
  for (x = 1; x <= _N; x++) {
    _Apa[x] = -1;
  }
  _Qnum = 0;
  _maxQ1 = _N - 3;
  _maxQ2 = _N * 2 / 3;
  _maxQ4 = _N / 2+2;
}  /*diInit*/

int GetN(){
  if (_Init) {
    _doInit();
    _Init = false;
  }
  return _N;
}  /*GetN*/

int _Find(int x){
  int k;
  int Nx = x;
  while (_Apa[Nx] > 0) {
    Nx = _Apa[Nx];
  }
  while (x != Nx) {
    k = _Apa[x];
    _Apa[x] = Nx;
    x = k;
  }
  return Nx;
}  /*_Find*/

 int _Unio(int nn, int mm){
  int k;
  if (nn == mm) {
    return nn;
  }
  if (_Apa[nn] > _Apa[mm]) {
    k = nn;
    nn = mm;
    mm = k;
  }
  _Apa[nn] += _Apa[mm];
  _Apa[mm] = nn;
  return nn;
}  /*_Unio*/

int isOnLine(int x, int y, int z){
  int nx, ny, nz,nn;
  int nxn = 0, nyn = 0, nzn = 0;
  int i;
  if (_Init) {
    _Fin(0, "Protocol error");
  }
  if (x < 1 || x > _N || y < 1 || y > _N || z < 1 || z > _N) {
    _Fin(0, "Protocol error");
  }
  _Qnum++;
  if (_Qnum > _maxQ1)
    _Fin(false, "Too many questions");

  if (x == y || y == z || y==z) {
    return 1;
  }
  nx = _Find(x);
  ny = _Find(y);
  nz = _Find(z);
  if (nx == ny && ny == nz) {
    return 1;
  }

  nxn = -_Apa[nx];  nyn = -_Apa[ny];  nzn = -_Apa[nz];
  nn=nxn+nyn+nzn;
  if (nx==ny) nn-=nyn;
  if (nx==nz) nn-=nzn;
  if (ny==nz) nn-=nzn;

  if (nn <= _N - 3) {
    nx = _Unio(nx, ny);
    nx = _Unio(nx, nz);
    return 1;
  }

  return 0;
}  /*isOnLine*/

void Answer(int a1, int b1, int a2, int b2){
  int na1, nb1, na2, nb2, pont;
  if (a1 < 1 || a1 > _N || b1 < 1 || b1 > _N || a2 < 1 || a2 > _N || b2 < 1 ||
      b2 > _N || a1==b1 || a2==b2) {
    _Fin(0, "Protocol error");
  }
  na1 = _Find(a1); nb1 = _Find(b1);
  na2 = _Find(a2); nb2 = _Find(b2);
   if (na1==nb1){
      if( (-_Apa[na1]==_N-3) && (na2!=na1) && (nb2!=na1) ||
			 (na2==nb2) && (na1!=na2) && (-(_Apa[na1]+_Apa[na2])>_N-3) )
         _Fin(true, "Correct");
      else
         _Fin(false, "Wrong answer");
   }else if (na2==nb2){
      if( (-_Apa[na2]==_N-3) && (na1!=na2) && (nb1!=na2) ||
			 (na1==nb1)&&(na1!=na2)&&(-(_Apa[na1]+_Apa[na2])>_N-3) )
         _Fin(true, "Correct");
      else
         _Fin(false, "Wrong answer");
   }else{
      _Fin(false, "Wrong answer");
   }
  _Fin(true, "Correct");
}
