unit office;
interface
	function GetN:longint;
	function isOnLine(x,y,z:longint):integer;
	procedure Answer(a1,b1,a2,b2:longint);

implementation
  const
    MaxN=100000;
    Init:boolean=true;
    digi:longint=129723562;
var
    N, Qnum,maxQ1,maxQ2,maxQ4:longint;
	Apa:array[0..MaxN] of longint;

procedure Fin(OK:boolean; S:String);
var point:integer;
  begin{}
     if OK then begin
		if Qnum<=maxQ4 then begin
			point:=4;
			S:=' <=N/2+2'
		end else if Qnum<=maxQ2 then begin
			point:=2;
			S:=' <=2N/3';
		end else begin
			point:=1;
			S:=' <=N-3';
		end;
       writeln(point);
       writeln('Correct');
       writeln('#Questions= ',Qnum,S);
       writeln(digi);
     end else begin
       writeln(0);
       writeln(S);
       writeln('#Questions= ',Qnum);
       writeln(digi);
     end;
     Halt;
  end{Fin};

procedure doInit;
  var  x:longint;
 begin{}
     readln(N);
     for x:=1 to n do 
         Apa[x]:=-1;
   Qnum:=0;
   maxQ1:=N-3;
   maxQ2:=(2*N) div 3;
   maxQ4:=N div 2+2;
end{doInit};

function GetN:longint;
  begin
    if Init then begin
      doInit;
      Init:=false;
    end;
    GetN:=N;
end{GetN};

function Find(x : longint):longint;
  var  k:longint;
    Nx:longint;
  begin
    Nx:=x;
    while Apa[Nx] > 0 do begin
       Nx:=Apa[Nx];
    end;
    while x <> Nx do begin 
        k:=Apa[x];
        Apa[x]:=Nx;
        x:=k
    end;
    Find:=Nx;
 end{Find};

function Unio(N,M : longint):longint;
  var
    k:longint;
  begin
    If (N=M) then begin
		Unio:=N; exit;
    end;
      If Apa[N] > Apa[M] then begin
        k:=N; N:=M; M:=k
      end;
      Apa[N]:=Apa[N] + Apa[M];
      Apa[M]:=N;
      Unio:=N;
 end{Unio};

function isOnLine(x,y,z:longint):integer;
var nx,ny,nz:longint;
	nxn,nyn,nzn,nn:longint;
begin{Question}
    if Init then begin
      Fin(false,'Protocol error');
    end;
    if (x<1)or(x>N)or(y<1)or(y>N)or(z<1)or(z>N) then begin
      Fin(false,'Protocol error');
    end;

    inc(Qnum);
    if (Qnum>maxQ1) then begin
       Fin(false,'too many isOnLine question');
    end;
    if (x=y) or (x=z) or (y=z) then begin
      isOnLine:=1;
      exit;
    end;
	nx:=Find(x); ny:=Find(y);  nz:=Find(z);
	if (nx=ny)and(ny=nz) then begin
		isOnLine:=1;
		exit;
	end;

	nxn:=-Apa[nx]; nyn:=-Apa[ny]; nzn:=-Apa[nz];
	nn:=nxn+nyn+nzn;
	if nx=ny then nn:=nn-nyn;
	if ny=nz then nn:=nn-nzn;
	if nx=nz then nn:=nn-nzn;
	if (nn<=n-3) then begin
		nx:=Unio(nx,ny); nx:=Unio(nx,nz);
		isOnLine:=1;
		exit;
	end;

	isOnLine:=0;	
end{isOnLine};

procedure Answer(a1,b1,a2,b2:longint);
var
	na1,nb1,na2,nb2:longint;
begin
	if (a1<1)or(a1>N)or(b1<1)or(b1>N)or(a2<1)or(a2>N)or(b2<1)or(b2>N)or
	    (a1=b1)or(a2=b2) then
			Fin(false,'Protocol error');
	na1:=Find(a1); nb1:=Find(b1);
	na2:=Find(a2); nb2:=Find(b2);
	if (na1=nb1)then begin
		if ((-Apa[na1]=n-3)and(na2<>na1)and(nb2<>na1))or
			((na2=nb2)and(na1<>na2)and(-(Apa[na1]+Apa[na2])>n-3)) then
			Fin(true,'Correct')
		else
			Fin(false,'Wrong answer');			
	end else if (na2=nb2) then begin
		if ((-Apa[na2]=n-3)and(na1<>na2)and(nb1<>na2))or
			((na1=nb1)and(na1<>na2)and(-(Apa[na1]+Apa[na2])>n-3)) then
			Fin(true,'Correct')
		else
			Fin(false,'Wrong answer');				
	end else begin
		Fin(false,'Wrong answer');
	end;
end;
begin end.
